import sys
import re

reBF = re.compile(r'/\*<BF>\*/\(function \(([^)]*)\)*\)\s+{/\*</BF>\*/') # => /*<BF>*/(function (\1) { /*</BF>*/
#reOB = re.compile(r'(.*)/\*<OB>\*/{/\*</OB>\*/')                        # => \1/*<OB>*/{/*</OB>*/
#reCB = re.compile(r'(.*)/\*<CB>\*/}/*</CB>\*/')                        # => \1/*<CB>*/}/*</CB>*/
reEF = re.compile(r'/\*<EF>\*/}\)\((.*?)\);?/\*</EF>\*/')               # => /*<EF>*/})(\1);/*</EF>*/
reL  = re.compile(r'/\*<L>\*/(.*?)/\*</L>\*/')                          # => /*<L>*/\1/*</L>*/
reC  = re.compile(r'/\* [^\*]+ \*/')
reOBEOL = re.compile(r'/\*<OB>\*/{/\*</OB>\*/\s+/\*</L>\*/\s*$')
reCBBOL = re.compile(r'^(\s*/\*<L>\*/\s*}|/\*<L>\*/\s+/\*<CB>\*/}/\*</CB>\*/)')

def jsexpand(program, level, expandlevel, inputfh, line):

    global output_line_count

    if not line:
        line = readline(inputfh)

    while line:

        #sys.stderr.write("================\n")
        #sys.stderr.write("program=%s\n" % program)
        #sys.stderr.write("level=%s\n" % level)
        #sys.stderr.write("line=%s\n" % line)

        subprogramtext = "" # set to null string to free memory

        line = line.strip()

        if not line:
            line = readline(inputfh)
            continue

        match = reBF.match(line)
        if match:
            #sys.stderr.write("match BF %s\n" % match.group(0))
            subprogramtext = match.group(0)
            subprogram = [subprogramtext]
            line = line[len(subprogramtext):]
            line = jsexpand(subprogram, level + 1, expandlevel, inputfh, line)
            if level < expandlevel:
                subprogramtext = '\n'.join(subprogram)
                output_line_count += len(subprogram) - 1
            else:
                subprogramtext = ' '.join(subprogram)

            if level == 0:
                print subprogramtext
                output_line_count += 1
            else:
                program.append(subprogramtext)

            if not line:
                line = readline(inputfh)
            continue

        match = reEF.match(line)
        if match:
            #sys.stderr.write("match EF %s\n" % match.group(0))
            subprogramtext = match.group(0)
            line = line[len(subprogramtext):]
            program.append(subprogramtext)
            return line

        #match = reOB.match(line)
        #if match:
        #    #sys.stderr.write("match OB %s\n" % match.group(0))
        #    subprogramtext = match.group(0)
        #    line = line[len(subprogramtext):]
        #    if level == 0:
        #        print subprogramtext
        #        output_line_count += 1
        #    else:
        #        program.append(subprogramtext)
        #    if not line:
        #        line = readline(inputfh)
        #    continue

        #match = reCB.match(line)
        #if match:
        #    #sys.stderr.write("match CB %s\n" % match.group(0))
        #    subprogramtext = match.group(0)
        #    line = line[len(subprogramtext):]
        #    if level == 0:
        #        print subprogramtext
        #    continue

        match = reL.match(line)
        if match:
            #sys.stderr.write("match L %s\n" % match.group(0))
            subprogramtext = match.group(0)
            line = line[len(subprogramtext):]
            if level == 0:
                print subprogramtext
                output_line_count += 1
            else:
                # hack empty blocks to same line if possible
                program.append(subprogramtext)
                if len(program) > 2:
                    openmatch = reOBEOL.search(program[-2])
                    closematch = reCBBOL.search(program[-1])
                    if openmatch and closematch:
                        program[-2] += ' ' + program[-1]
                        program.pop()
            if not line:
                line = readline(inputfh)
            continue

        match = reC.match(line)
        if match:
            #sys.stderr.write("match C %s\n" % match.group(0))
            subprogramtext = match.group(0)
            line = line[len(subprogramtext):]
            if level == 0:
                print subprogramtext
                output_line_count += 1
            else:
                program.append(subprogramtext)
            if not line:
                line = readline(inputfh)

    return line

def readline(fh):
    global input_line_count

    line = fh.readline()
    if line:
        input_line_count += 1

    return line

if __name__ == "__main__":

    input_line_count = 0
    output_line_count = 0

    program     = []
    inputfile   = sys.argv[1]
    expandlevel = int(sys.argv[2])

    inputfh = open(inputfile, 'r')

    jsexpand(program, 0,  expandlevel, inputfh, None)

    inputfh.close()

    if input_line_count == output_line_count:
        sys.exit(1)
