#!/bin/bash

lithium=$1
firefox=$2

echo $lithium
echo $firefox

if [[ -z "$lithium" || -z "$firefox" ]]; then
    echo "Usage: run-test.sh pathtolithium pathtofirefox"
    exit 2
fi

if [[ ! -d "$lithium" ]]; then
    echo "Lithium directory $lithium does not exist."
    exit 2
fi

if [[ ! -x "$firefox" ]]; then
    echo "Firefox $firefox does not exist or is not executable."
    exit 2
fi

source ./setmoz.sh

let t=0;
while $firefox -P lithium ./cross_fuzz_randomized_20110105_seed.html?run > output.log 2>&1; do
    let t=t+1;
    echo $t `ls -lah output.log`;
done;

echo $t exit code $? `ls -lah output.log`;

LITHIUM=$lithium FIREFOX=$firefox make reduce
